#pragma once

#define OF_ADDON_USING_OFXVECTORMATH
#define OF_ADDON_USING_OFXOPENCV

#include "ofMain.h"
#include "ofAddons.h"

#define MAX_CONTOURS 10000
#define NUM_CARDS 9
#define MIN_CARD_AREA 320

#define CARD_CV_W 64
#define CARD_CV_H 80


// [zach] added this... for corner detection, so we can draw the corner finder routine... otherwise, we loose it
#include "cornerFinderBlob.h"




class card{

	public:
	

	//---------------------------------------------
	card(){
		reset();
		myCardImage.allocate(CARD_CV_W,CARD_CV_H, OF_IMAGE_GRAYSCALE);
	}

	//---------------------------------------------
	int getSuit(){
		return suit;
	}

	//---------------------------------------------
	int getCard(){
		cardNumber = 1 + (whichCard-1) % 13;
		return cardNumber;
	}
	
	//---------------------------------------------
	void reset(){
		pta	= ptb = ptc = ptd = 0;
		good		= false;
		pixelRatio	= 0.0;
		whichCard	= -1;
		suit		= -1;
		cardNumber	= -1;
		angle		= 0.0;
		hu			= 0.0;
		
		boundingRect.x = 0;
		boundingRect.y = 0;
		boundingRect.width = 0;
		boundingRect.height = 0;
		
		for(int i = 0; i < 4; i++){
			c[i] = 0;
		}
	}

	//---------------------------------------------
	void setBoundingRect(ofRectangle bounding){
		memcpy(&boundingRect, &bounding, sizeof(ofRectangle));
	}
	
	//---------------------------------------------
	void setPoints(ofxVec2f pt1, ofxVec2f pt2, ofxVec2f pt3, ofxVec2f pt4){
		c[0] = pt1;
		c[1] = pt2;
		c[2] = pt3;
		c[3] = pt4;
		
		good = true;
	}

	//-------------------
	//-------------------
	
	ofxVec2f c[4];
	bool good;
	float pixelRatio;
	
	// [zach] added some additional code here to show how close these things are:
	
	int		whichCard;
	float	diff;
	
	int whichCardHu[3];
	float diffHu[3];

	
	int suit;
	int cardNumber;
	int pta;
	int ptb;
	int ptc;
	int ptd;
	float angle;
	float hu;
	ofxVec2f center;
	
	ofRectangle boundingRect;
	CvMoments Moments;
	CvHuMoments HuMoments;	
	
	// [zach] 
	cornerFinderBlob  CFB;
	
	ofImage		myCardImage;
				
};




