#include "cardGemoetry.h"



//-----------------------------
void cardGemoetry::identifyShortestSide(card &theCard){
	int dist = 999999;
	int pta	 = 0;
	int ptb  = 0;
	
	for(int i = 0; i < 4; i++){
		for(int j = 0; j < i; j++){
			float d = sqrt( pow(theCard.c[i].x - theCard.c[j].x , 2) + pow(theCard.c[i].y - theCard.c[j].y , 2) );
			
			if(d < dist){
				pta = i;
				ptb = j;
				dist = d;
			}
		 }
	}
	
	//printf("pta is %i ptb is %i \n", pta, ptb);
	
	theCard.pta = pta;
	theCard.ptb = ptb;
	
}

//-----------------------------
void cardGemoetry::calculatePointOrder(card &theCard){
	
	identifyShortestSide(theCard);
	
	int pta = theCard.pta;
	int ptb = theCard.ptb;
	
	int ptc = -1;
	int ptd = -1;
	
	for(int j = 0; j < 4; j++){
		if(j != pta && j != ptb && ptc < 0)ptc = j;
		else if(j != pta && j != ptb && j != ptc && ptd < 0)ptd = j;
	}

	float distPtbToPtc  =  sqrt( pow(theCard.c[ptb].x - theCard.c[ptc].x, 2) + pow(theCard.c[ptb].y - theCard.c[ptc].y, 2) );	
	float distPtbToPtd  =  sqrt( pow(theCard.c[ptb].x - theCard.c[ptd].x, 2) + pow(theCard.c[ptb].y - theCard.c[ptd].y, 2) );	
	
	if( distPtbToPtd < distPtbToPtc ){
		int tmp = ptd;
		ptd = ptc;
		ptc = tmp;
	}
							
	theCard.ptc = ptc;
	theCard.ptd = ptd;
}

//-----------------------------
void cardGemoetry::calculateCenter(card &theCard){
	float avgX = 0;
	float avgY = 0;
	
	for(int i = 0; i < 4; i ++){
		avgX += theCard.c[i].x;
		avgY += theCard.c[i].y;				
	}
	
	avgX /= 4;
	avgY /= 4;
	
	theCard.center.x = avgX;
	theCard.center.y = avgY;
}

//-----------------------------
void cardGemoetry::calculateAngle(card &theCard){
	float midPointX = 0.5 * theCard.c[ theCard.pta ].x + 0.5 * theCard.c[ theCard.ptb ].x; 
	float midPointY = 0.5 * theCard.c[ theCard.pta ].y + 0.5 * theCard.c[ theCard.ptb ].y; 
		
	float dx = midPointX - theCard.center.x;
	float dy = midPointY - theCard.center.y;
		
	float angle = atan2(dy, dx);
	
	theCard.angle = angle;
}	

//-----------------------------
void cardGemoetry::calculateGeometry(card &theCard){
	calculatePointOrder( theCard );
		
	int pta = theCard.pta;
	int ptb = theCard.ptb;
	int ptc = theCard.ptc;
	int ptd = theCard.ptd;
	
	/*
	 rotate 180 degrees, means things come not flipped... better
	*/

	if ( theCard.c[pta].y < theCard.c[ptc].y){
		theCard.pta = ptd;
		theCard.ptb = ptc;
		theCard.ptc = ptb;
		theCard.ptd = pta;
	}
	

	calculateCenter(theCard);
	calculateAngle(theCard);
	
	
	
}



								
				